package Session;

import java.util.*;
import java.lang.reflect.*;
import java.io.*;

import javax.servlet.*;
import javax.servlet.http.*;

/**
** SessionData is a servlet which add specified number of characters 
** to session and retrive them , by default it add/retrive 2000 characters.
*/
public class SessionData extends HttpServlet
{
    public void service(HttpServletRequest req, HttpServletResponse res)
                    throws ServletException, IOException
    {
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	 out.println("Executed From Instance: <b>"+System.getProperty("com.sun.aas.instanceName") +"</b><br>");

        HttpSession session = req.getSession();

        int numChars=0;
        String strNumChars = req.getParameter("numChars");
        if(null==strNumChars)
            numChars = 2000; // 2k session by default
        else
            numChars = Integer.parseInt(strNumChars); 
        // Can throw exception, but then it is the responsibility and validity of the request

        char[] ret = Cache.getInstance().getData(numChars);
        StringBuffer store = new StringBuffer(ret.length);
        store.append(ret);

        String output = "SessionID=" + session.getId() + " has stored data of " + ret.length + " characters.";
        out.println(output + "<br>");

	String dataName = req.getParameter("dataname");

     if (dataName != null) {
        session.setAttribute(dataName, store);
	Enumeration names = session.getAttributeNames();
        while (names.hasMoreElements()) {
                String name = (String) names.nextElement();
                String value = session.getAttribute(name).toString();
                out.println(name + " = " + value + "<br>");
                out.println("session data size : " + value.length() + "<br>");
     		}
      } else 
	{
	session.setAttribute("dataName", store);
	String value = session.getAttribute("dataName").toString();
        out.println("dataName = " + value + "<br>");
        out.println("session data size : " + value.length() + "<br>");
	}

	out.println("sessions is new : " + " " + session.isNew() + "<br>");
	out.println("sessions is created : " + " ");
	out.println(new Date(session.getCreationTime()) + "<br>");
        out.println("sessions is lastaccessed : " + " ");
        out.println(new Date(session.getLastAccessedTime()));
        out.println("<br>");
        out.println("sessions is requestedid : " + " " + req.getRequestedSessionId() + "<br>");
        out.println("sessions requestedidvalid : " + " " + req.isRequestedSessionIdValid() + "<br>");
        out.println("sessions is fromcookie : " + " " + req.isRequestedSessionIdFromCookie() + "<br>");
        out.println("sessions is fromurl : " + " " + req.isRequestedSessionIdFromURL() + "<br>");

        System.out.println(output + Calendar.getInstance().getTime().toString());
    }
}
